<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<ng-container *ngLet="item$ | async as item">
  <app-role-checker [allowedRoles]="[admin, nodeOperator]">
    <ng-template let-authorized>
      <div *ngIf="adapterConnections.length == 1 && item" class="flex flex-col gap-4 items-start pb-16">
        <div>
          <app-create-connection-button
            *ngIf="op == 'READ'"
            op="WRITE"
            [oid]="item.oid"
            [prop]="item.prop"
            class="text-skyBlue"
            [disabled]="!authorized"
          ></app-create-connection-button>
          <app-create-connection-button
            *ngIf="op == 'WRITE'"
            op="READ"
            [oid]="item.oid"
            [prop]="item.prop"
            class="text-grassGreen"
            [disabled]="!authorized"
          ></app-create-connection-button>
        </div>
        <app-info *ngIf="!authorized" message="Insufficient role to add adapter connection."></app-info>
      </div>
      <div class="w-full">
        <div class="flex gap-4 pb-4 h-16 items-center">
          <div class="text-text-500 text-md font-semibold flex items-center leading-none gap-2">
            <i class="pi pi-link" style="font-size: 1rem"></i>
            <div>Adapter connection</div>
          </div>
        </div>
        <div *ngIf="noConnections">
          <p-message
            severity="info"
            text="Unable to consume data because this property has no connections to any adapters."
          ></p-message>
          <div *ngIf="item" class="mt-8">
            <div class="text-base font-semibold text-text-500 leading-none">
              Do you want to setup adapter connection now?
            </div>
            <div class="flex flex-col gap-4 items-start mt-4">
              <div class="flex items-center gap-4">
                <app-create-connection-button
                  op="READ"
                  [oid]="item.oid"
                  [prop]="item.prop"
                  class="text-grassGreen"
                  [disabled]="!authorized"
                ></app-create-connection-button>
                <app-create-connection-button
                  op="WRITE"
                  [oid]="item.oid"
                  [prop]="item.prop"
                  class="text-skyBlue"
                  [disabled]="!authorized"
                ></app-create-connection-button>
              </div>
              <app-info *ngIf="!authorized" message="Insufficient role to add adapter connection."></app-info>
            </div>
          </div>
        </div>
        <div *ngIf="!noConnections" class="w-full flex flex-col items-end">
          <div class="grow border bg-secondary-900 rounded-sm border-secondary-900 w-full">
            <div class="px-3 pb-6">
              <p-tabView (onChange)="onTabChange($event)" [(activeIndex)]="activeIndex">
                <p-tabPanel
                  *ngFor="let connection of adapterConnections$ | async; index as i"
                  [selected]="activeIndex == i"
                >
                  <ng-template pTemplate="header" let-active>
                    <div
                      class="flex gap-4 text-base font-semibold items-center justify-center"
                      [ngClass]="{ 'text-primary-500': activeIndex == i, 'text-white': activeIndex != i }"
                    >
                      <i [ngClass]="[connection.op == 'READ' ? 'pi pi-download ' : 'pi pi-upload ']"></i>
                      <div>{{ connection.op | titlecase }}</div>
                    </div>
                  </ng-template>
                  <div class="mt-6">
                    <app-connection-detail
                      *ngIf="adapter"
                      [adapter]="adapter"
                      [connection]="connection"
                    ></app-connection-detail>
                  </div>
                </p-tabPanel>
              </p-tabView>
            </div>
          </div>
        </div>
      </div>
    </ng-template>
  </app-role-checker>
</ng-container>
